var smartpack = {

	// Variables
	wp_url: smartpack_ajax_object.ajax_url,
	drop_points: [],
	address: {},
	drop_point: {},

	translate: function (key) {
		var result = window.smartpack_lang[('' + key).toLowerCase()];
		if (result) return result;
		return key;
	},

	select_drop_point: function(id) {
		var drop_point = smartpack.drop_points.find(function(x) {
			if (!x.id) {
				return false
			}

			return x.id.toString() === id
		})

		smartpack.drop_point = drop_point

		if(smartpack.modal) {
			smartpack.modal.close()

      var drop_point_containers = document.getElementsByClassName('smartpack-selected-drop-point')
      Array.prototype.forEach.call(drop_point_containers, function(container) {
        container.classList.remove('smartpack-hidden')
      })

      var drop_point_info_fields = [
        {
          key: 'smartpack-selected-name',
          value: smartpack.drop_point.name
        },
        {
          key: 'smartpack-selected-address',
          value: smartpack.drop_point.address.street1
        },
        {
          key: 'smartpack-selected-zip',
          value: smartpack.drop_point.address.zipcode + ' ' + smartpack.drop_point.address.city
        }
      ]

      drop_point_info_fields.forEach(function(field) {
        elements = document.getElementsByClassName(field.key)
        Array.prototype.forEach.call(elements, function(element) {
          element.innerHTML = field.value
        })
      })
		}

		var dp = window.smartpack.drop_point;
		var blob = encodeURIComponent(JSON.stringify({
			id: dp.id,
			street1: dp.address.street1,
			zipcode: dp.address.zipcode,
			city: dp.address.city,
			country: dp.address.country,
			name: dp.name
		}))

    sp_drop_point_blobs = document.getElementsByName('sp_drop_point_blob')
    Array.prototype.forEach.call(sp_drop_point_blobs, function(drop_point_blob) {
      drop_point_blob.value = blob
    })
	},

	// Get and set shops by address
	search: function(zip, adr, callback){
		// Make the call
		jQuery.post( smartpack.wp_url, {
			action: "get_shops",
			address: adr,
			zip: zip,
		}, function (response) {
			if(! response.data || ! response.data.drop_points) {
				window.smartpack.drop_points = []
			} else {
				smartpack.drop_points = response.data.drop_points;
			}

			if(typeof callback !== 'undefined') {
				callback()
			}
		}, "json").fail(function () {
				smartpack.drop_points = [];
		});
	}
};